// ignore: implementation_imports
import 'package:analyzer/src/dart/constant/value.dart';

// ignore: implementation_imports
import 'package:analyzer/src/dart/element/type.dart';

import 'package:build/build.dart';

import 'dart:async';
import 'package:analyzer/dart/element/element.dart';
import 'package:dao_wrapped_annotation/dao_wrapped_annotation.dart';
import 'package:source_gen/source_gen.dart';
import 'src/create_table.dart';

class DaoTableGenerator extends GeneratorForAnnotation<DaoTable> {
  @override
  FutureOr<String> generateForAnnotatedElement(
      Element element, ConstantReader annotation, BuildStep buildStep) {
    var tableOut = "";
    try {
      final annotationValue = annotation.objectValue as DartObjectImpl;

      final annotationFields = annotationValue.fields;

      final model = (annotationFields["model"] // ignore: unnecessary_cast
              as DartObjectImpl)
          .toTypeValue() as InterfaceTypeImpl;

      final primaryKey =
          (annotationFields["primaryKey"] // ignore: unnecessary_cast
                  as DartObjectImpl)
              .toStringValue();

      tableOut += CreateTable().create(model, primaryKey);
    } catch (e) {
      print("error: $e \n");
    }
    return tableOut;
  }
}
